# Losignoi --Local Signal-Noise separation in  2D 
#		most of the 3-D code is present, missing losignoi3()
#
#  <in.H Losignoi [options] > out.H
#		n1,n2,n3	wall sizes
#		w1,w2,w3	window sizes
#		k1,k2,k3	number of windows
#		a1,a2,a3	PEF size.
#
#     default	a2=2,a3=1	
#%
integer n1,n2,n3, w1,w2,w3,  k1,k2,k3, a1,a2,a3,f1,f2,f3

from history:	integer n1, n2, n3=1

f1=min(n1,20); f2=min(n2,20); f3=min(n3,6);
from par:       integer w1=f1,w2=f2,w3=f3

from par:     integer a1       = 5
from par:     integer a2       = 2
from par:     integer a3       = 1

from par:     integer k1       = (1.5 * n1)/w1
from par:     integer k2       = (1.5 * n2)/w2
from par:     integer k3       = (1.5 * n3)/w3

allocate:     real datr(n1,n2,n3)
allocate:     real resi(n1,n2,n3)
allocate:     real sign(n1,n2,n3)

subroutine doit( n1,n2,n3,w1,w2,w3,k1,k2,k3, a1,a2,a3, datr,resi,sign)
integer          n1,n2,n3,w1,w2,w3,k1,k2,k3, a1,a2,a3
integer	   i1,i2,i3, miter
real	datr(n1,n2,n3),                 big, epsilon
real	resi(n1,n2,n3)
real	sign(n1,n2,n3)
integer iseed
real	rand01

from par:	integer miter=a1*a2*a3
from par:	real	epsilon=.1
call sreed(  'in',  datr, 4*n1*n2*n3)
big= 0.
do i1=1,n1
do i2=1,n2
do i3=1,n3
        if(     big < abs( datr(i1,i2,i3)) )
                big = abs( datr(i1,i2,i3))
#                                                             iseed=1993

# I think it is no longer necessary to add noise to the datr
#	since zero traces are now automatically excluded.
# wrong!  In some windows, _everything_ is missing.

do i1=1,n1
do i2=1,n2
do i3=1,n3
        datr(i1,i2,i3) = datr(i1,i2,i3)/big  + .0001 * rand01(iseed)

call putlin(' subtracting estimated noise')

call losn2( datr, sign, n1,n2,w1,w2,k1,k2, epsilon, miter, a1,a2)

#ne losn2(  datr, sign, n1,n2,w1,w2,k1,k2, epsilon, miter, a1,a2)

call srite('out', sign, 4*n1*n2*n3)
call hclose()
return;end
