# Pred ---  Prediction in  2D or 3D.
#
#  <in.H Pred [options] > out.H
#		n1,n2,n3	wall sizes
#		w1,w2,w3	window sizes
#		k1,k2,k3	number of windows
#		a1,a2,a3	PEF size.
#
#     default	a2=2,a3=1	in-line     2-D PEFs only.
#               a2=1,a3=2	out-of-line components.
#%
integer n1,n2,n3, w1,w2,w3,  k1,k2,k3, a1,a2,a3,f1,f2,f3

from history:	integer n1, n2, n3=1

f1=min(n1,20); f2=min(n2,20); f3=min(n3,6)
from par:       integer w1=f1,w2=f2,w3=f3

from par:     integer a1       = 5
from par:     integer a2       = 2
from par:     integer a3       = 1

from par:     integer k1       = 1.5 * n1/(w1-a1+1.)
from par:     integer k2       = 1.5 * n2/(w2-a2+1.)
from par:     integer k3       = 1.5 * n3/(w3-a3+1.)

allocate:     real datr(n1,n2,n3),     afre(a1,a2,a3)
allocate:     real resi(n1,n2,n3)
allocate:     real sign(n1,n2,n3)

subroutine doit( n1,n2,n3,w1,w2,w3,k1,k2,k3, afre,a1,a2,a3, datr,resi,sign)
integer          n1,n2,n3,w1,w2,w3,k1,k2,k3,      a1,a2,a3
integer	niter,	    i1,i2,i3, lag1,lag2,lag3
integer iseed,                gap1,gap2,gap3
real	datr(n1,n2,n3),                 rand01, big,   afre(a1,a2,a3)
real	resi(n1,n2,n3),        dot, signvar, datrvar
real	sign(n1,n2,n3)

from par:	integer gap1=0,          gap2=0, gap3=0
from par:	integer lag1=(a1+1)/2.,  lag2=1, lag3=1
from par:	integer niter=a1*a2*a3
call sreed(  'in',  datr, 4*n1*n2*n3)
big= 0.
do i1=1,n1
do i2=1,n2
do i3=1,n3
        if(     big < abs( datr(i1,i2,i3)) )
                big = abs( datr(i1,i2,i3))
                                                             iseed=1993
#   I believe with the new pef(), noise is no longer needed.
do i1=1,n1
do i2=1,n2
do i3=1,n3
        datr(i1,i2,i3) = datr(i1,i2,i3)/big   #   + .0001 * rand01(iseed)


call putlin(' making local signiction error')
call spatialpef( lag1,lag2,lag3, gap1,gap2,gap3, afre,a1,a2,a3)
do i1= 1, a1
	print '(10f6.1)', ( afre(i1,i2,1),i2=1,a2)
#call lopef2( n1,n2,w1,w2,k1,k2, niter,lag1,lag2,afre,a1,a2, datr,resi )
call lopef2( datr,resi, n1,n2,w1,w2,k1,k2, niter,lag1,lag2,afre,a1,a2)
do i1=1,n1
do i2=1,n2
do i3=1,n3
	sign(i1,i2,i3) = datr(i1,i2,i3) - resi(i1,i2,i3)
signvar = sqrt( dot( n1*n2*n3, sign, sign) )
datrvar = sqrt( dot( n1*n2*n3, datr, datr) )
do i3=1,n3
do i2=1,n2
do i1=1,n1
	if(     resi(i1,i2,i3) == 0.)
		sign(i1,i2,i3) = datr(i1,i2,i3) * signvar / datrvar

call hclose()
call srite(  'out', sign, 4*n1*n2*n3 )

return; end

real function dot( n, x, y )
integer i, n;           real val, x(n), y(n)
val = 0.;       do i=1,n  { val = val + x(i) * y(i) }
dot = val;      return;         end

