# Lomoplancm ---  LOcal MOno PLane ANnihilator, 2D or 3D.
#
#  <in.H Lomoplancm [options] > out.H
#		n1,n2,n3	wall sizes
#		w1,w2,w3	window sizes
#		k1,k2,k3	number of windows
#		a1,a2,a3	PEF size.
#
#     default	a2=2,a3=1	in-line     2-D PEFs only.
#               a2=1,a3=2	out-of-line components.
#		postrect=1	post smoothing the 1-axis
#               kd3=1           number of crossline cubes to process per pass
#%
integer n1,n2,n3, w1,w2,w3,  k1,k2,k3, kd3, a1,a2,a3,f1,f2,f3

from history:	integer n1, n2, n3=1


f1=min(n1,20); f2=min(n2,20); f3=min(n3,6)
from par:       integer w1=f1,w2=f2,w3=f3

from par:     integer a1       = 5
from par:     integer a2       = 2
from par:     integer a3       = 1

from par:     integer k1       = 1.5 * n1/(w1-a1+1.)
from par:     integer k2       = 1.5 * n2/(w2-a2+1.)
from par:     integer k3       = 1.5 * n3/(w3-a3+1.)

from par:     integer kd3       = 1

allocate:	real modl  (n1,n2,n3), resi(n1,n2,n3), free(a1,a2,a3)

subroutine dicesaw( n1,n2,n3, w1,w2,w3, k1,k2,k3, kd3, free,a1,a2,a3, modl,resi)
integer             n1,n2,n3, w1,w2,w3, k1,k2,k3, kd3,      a1,a2,a3
integer		    i1,i2,i3, lag1,lag2,lag3, gap1,gap2,gap3, niter
integer iseed, postrect1
real	modl(n1,n2,n3), resi(n1,n2,n3), rand01, big,   free(a1,a2,a3)
real	d1,d2,d3, vel, tgap, varat
double precision dot

character*80  process

# These lines are commented out because of a bug in RATFOR90
#if ( getch('process','s',process) != 0 ) 
#	call putch('The process applied is process','s', process) 
#else 
#	call erexit('Need to specify a process, such as process=lomoplan')

# These lines are needed because of a bug in RATFOR90
if ( getch('process','s',process) != 0 )  {
	call putch('The process applied is process','s', process) 
	}
else  {
	call erexit('Need to specify a process, such as process=lomoplan')
	}

call sreed(  'in',  modl, 4*n1*n2*n3)

big= 0.
do i1=1,n1
do i2=1,n2
do i3=1,n3
        if(     big < abs( modl(i1,i2,i3)) )
                big = abs( modl(i1,i2,i3))
                                                             iseed=1993
do i1=1,n1
do i2=1,n2
do i3=1,n3
        modl(i1,i2,i3) = modl(i1,i2,i3)/big + .0001 * rand01(iseed)

from par:	integer lag1=(a1+1)/2.,  lag2=1, lag3=1
from par:	integer gap1=0,          gap2=0, gap3=0
from par:       integer postrect1=   1

from history:	real d1,d2,d3=1.
from par:       real vel=1.7, tgap=.030

call setfree( process, lag1,lag2,lag3, free, a1,a2,a3, niter, _
	gap1,gap2,gap3, _
	d1,d2,d3,vel,tgap)

call lopef2( modl, resi, n1,n2, w1,w2, k1,k2, niter, lag1,lag2, free, a1,a2)

#ine lopef2( datr, resi, n1,n2,w1,w2,k1,k2, niter, lag1,lag2, afre, a1,a2)

if     ( process(1:8) == 'lomoplan' ) {
	call triangle2( postrect1, 1, n1, n2*n3, resi, resi)
	if( a2*a3 > 2 ) call erexit(' a2*a3 > 2 is not LOMOPLAN')
	}

else if( process(1:9) == 'predicted' ) {
	do i1=1,n1
	do i2=1,n2
	do i3=1,n3
		resi(i1,i2,i3) = modl(i1,i2,i3) - resi(i1,i2,i3)
	}

else if ( process(1:5) == 'PEF2D' ) {
	call triangle2( postrect1, 1, n1, n2*n3, resi, resi)
	}
else if ( process(1:8) == 'SteepCut' ) {
	varat = sqrt( dot( n1*n2*n3 , resi, resi) /  _
	              dot( n1*n2*n3 , modl, modl) )

	do i3=1,n3
	do i2=1,n2
	do i1=1,n1
		if( resi(i1,i2,i3) == 0.)
			resi(i1,i2,i3) = modl(i1,i2,i3) * varat
	}

call hclose()
call srite(  'out', resi, 4*n1*n2*n3 )
return; end

double precision function dot( n, x, y )
integer i, n;           real  x(n), y(n);       double precision val
val = 0.;       do i=1,n  { val = val + x(i) * y(i) }
dot = val;      return;         end
