! <in.H  Nmo3 vel=1.48 n3=7  > out.H
program zyxabc
implicit none
real, allocatable, dimension (:,:,:) :: tt
real, allocatable, dimension (:,:,:) :: zz
real, allocatable, dimension (:) :: slow
!
integer n1, n2,     esize
integer hetch,putch
call initpar()
call doc('/home/kana/sep/prof/gee/pch/mideast/Nmo3.rst')
  if (0>= hetch('n1','d',n1 )) then
    call erexit('Trouble reading  n1 from history  ')
  end if
  if (0.ne.putch('Read  from history : n1 ','d',n1)) then
    call erexit('Trouble writing n1 to history')
  end if
  if (0>= hetch('n2','d',n2 )) then
    call erexit('Trouble reading  n2 from history  ')
  end if
  if (0.ne.putch('Read  from history : n2 ','d',n2)) then
    call erexit('Trouble writing n2 to history')
  end if
  if (0>= hetch('n3','d',n3 )) then
    call erexit('Trouble reading  n3 from history  ')
  end if
  if (0.ne.putch('Read  from history : n3 ','d',n3)) then
    call erexit('Trouble writing n3 to history')
  end if
  if (0>= hetch('esize','d',esize )) then
    call erexit('Trouble reading  esize from history  ')
  end if
  if (0.ne.putch('Read  from history : esize ','d',esize)) then
    call erexit('Trouble writing esize to history')
  end if
if (esize .ne.4) then
  call erexit('esize != 4')
end if
allocate (tt(n1,n2,n3), zz(n1,n2,n3), slow(n1))
call dumb ( n1,n2,n3, slow, tt, zz)
end program zyxabc 
subroutine dumb( n1,n2,n3, slow, tt, zz)
integer	i1,i2,i3, n1,n2,n3
real median
real	slow(n1), tt(n1,n2,n3), zz(n1,n2,n3), vel, x,y,r, o1,d1,o2,d2,o3&
  &,d3
integer getch,hetch,putch
  if (0>= hetch('o1','f',o1 )) then
    call erexit('Trouble reading  o1 from history  ')
  end if
  if (0.ne.putch('Read  from history : o1 ','f',o1)) then
    call erexit('Trouble writing o1 to history')
  end if
  if (0>= hetch('d1','f',d1 )) then
    call erexit('Trouble reading  d1 from history  ')
  end if
  if (0.ne.putch('Read  from history : d1 ','f',d1)) then
    call erexit('Trouble writing d1 to history')
  end if
  if (0>= hetch('o2','f',o2 )) then
    call erexit('Trouble reading  o2 from history  ')
  end if
  if (0.ne.putch('Read  from history : o2 ','f',o2)) then
    call erexit('Trouble writing o2 to history')
  end if
  if (0>= hetch('d2','f',d2 )) then
    call erexit('Trouble reading  d2 from history  ')
  end if
  if (0.ne.putch('Read  from history : d2 ','f',d2)) then
    call erexit('Trouble writing d2 to history')
  end if
  if (0>= hetch('o3','f',o3 )) then
    call erexit('Trouble reading  o3 from history  ')
  end if
  if (0.ne.putch('Read  from history : o3 ','f',o3)) then
    call erexit('Trouble writing o3 to history')
  end if
  if (0>= hetch('d3','f',d3 )) then
    call erexit('Trouble reading  d3 from history  ')
  end if
  if (0.ne.putch('Read  from history : d3 ','f',d3)) then
    call erexit('Trouble writing d3 to history')
  end if
  if (0>= getch('vel','f',vel )) then
    vel = 1.44
  end if
  if (0.ne.putch('Read  from par : vel ','f',vel)) then
    call erexit('Trouble writing vel to history')
  end if
call sreed('in', tt, 4*n1*n2*n3)
call hclose()	! no more putch
do i1= 1, n1
  slow(i1) = (1./vel) 
end do 
do i3= 1, n3  
  do i2= 1, n2  
    x = o2 + d2 * (i2-1)
    y = o3 + d3 * (i3-1)
    r = sqrt( x*x + y*y)
    call nmo0( 1, 0, slow, r, o1, d1, n1, zz(1,i2,i3), tt(1,i2,i3) )
    median = 0
    do i1= 1, n1
      median = median + abs(zz(i1,i2,i3))
    end do 
    do i1= 1, n1
      zz(i1,i2,i3) = zz(i1,i2,i3)/median
    end do
  end do
end do 
call srite( 'out', zz, 4*n1*n2*n3) 
return
end
subroutine nmo0( adj, add, slow,    x, t0, dt, n,zz,  tt )
integer  it, iz, adj, add,                        n
real  xs, t , z,           slow(n), x, t0, dt, zz(n), tt(n)
call adjnull(    adj, add,                     zz,n,  tt,n)
do iz= 1, n  
  z = t0 + dt*(iz-1)
  xs= x * slow(iz)
  t = sqrt ( z*z + xs*xs)
  it= 1.5 + (t - t0) / dt
  if ( it <= n ) then
    if ( adj .eq. 0 ) then
      tt(it) = tt(it) + zz(iz)
    else
      zz(iz) = zz(iz) + tt(it)
    end if
  end if
end do 
return
end  
