program Idempatch
  use sep
  use helix
  use helicon
  use tent
  use patching

  implicit none
  integer,       dimension (:), pointer     :: n, w, k, a, l
  real,          dimension (:), allocatable :: wall, data, windwt
  type (filter)                             :: aa

  call sep_init ()
  allocate (n (2), w (2), k (2), a (2), l (2))
  call from_par ("n1"  ,n(1),100) ; call from_par ("n2"  ,n(2),30)
  call from_par ("w1"  ,w(1),17 ) ; call from_par ("w2"  ,w(2),6 )
  call from_par ("k1"  ,k(1),5  ) ; call from_par ("k2"  ,k(2),11)
  call from_par ("a1"  ,a(1),1  ) ; call from_par ("a2"  ,a(2),1 )
  call from_par ("lag1",l(1),1  ) ; call from_par ("lag2",l(2),1 )
  call to_history ("esize",4)
  call sep_close ()

  allocate (wall   (n (1)* n (2)))
  allocate (data  (n (1)* n (2)))
  allocate (windwt (w (1)* w (2)))

  wall = 1.

  call allocatehelix ( aa, 1)
  aa%lag = 1

  call tentn (w, l, a, windwt)
  call sep_write (windwt, "wind.H")
  call helicon_init (aa)
  call patchingn (helicon_lop, wall, data, k, n, w, windwt)

  data (1::n(1)) = 0
  data (2::n(1)) = 0
  data (n(1)-1::n(1)) = 0.
  data (n(1)::n(1)) = 0.

  call sep_write (data)

  call deallocatehelix ( aa)
  deallocate (wall, data, windwt)
  call exit (0)
end program Idempatch

