module decon2

use icai2
use mask_mod
use pef_mod

implicit none

real, dimension (:,:),    pointer, private	:: aa
integer, dimension (2),            private	:: na, lg
logical, parameter,                private 	:: F = .false.
logical, dimension (:,:), pointer, private	:: mx, ma
integer, 			   private	:: niter

interface decon2_init
	module procedure predict_decon2_init
	module procedure steep_dip_decon2_init
end interface

contains

subroutine steep_dip_decon2_init (nx, a, vel, tgap, d)

integer, dimension (2), intent (in)	:: nx, a
real, intent (in)			:: vel, tgap
real, dimension (2), intent (in)	:: d
real, dimension (nx (1), nx (2))	:: xx

na = a

allocate (aa (na (1), na (2))) 
allocate (ma (na (1), na (2))) 
allocate (mx (nx (1), nx (2)))

xx = 1. 
call find_mask (xx, aa, nx, lg, mx, ma, vel, tgap, d, niter)

call icai2_init (aa, nx)

end subroutine steep_dip_decon2_init

subroutine predict_decon2_init (nx, a, lag, gap)

integer, dimension (2), intent (in)	:: nx, a, lag, gap
real, dimension (nx (1), nx (2))	:: xx

na = a
lg = lag

allocate (aa (na (1), na (2))) 
allocate (ma (na (1), na (2))) 
allocate (mx (nx (1), nx (2)))

xx = 1. 
call find_mask (xx, aa, nx, lg, mx, ma, niter, gap)

call icai2_init (aa, nx)

end subroutine predict_decon2_init

function decon2_img (data, resi) result (stat)

integer					:: stat
real, dimension (:,:), pointer		:: data
real, dimension (:,:), intent (out)	:: resi

integer					:: stat1

call find_pef (data, aa, na, lg, mx, ma, niter)

stat1 = icai2_img (data, resi)
stat = 0

end function decon2_img

subroutine decon2_close ()

deallocate (aa, mx, ma)

end subroutine decon2_close

end module decon2


